---
title: Live streaming web audio and video
slug: Web/Guide/Audio_and_video_delivery/Live_streaming_web_audio_and_video
tags:
  - Guide
  - adaptive streaming
---
<div class="summary">
<p><span class="seoSummary">Live streaming technology is often employed to relay live events such as sports, concerts and more generally TV and Radio programmes that are output live. Often shortened to just streaming, live streaming is the process of transmitting media 'live' to computers and devices. This is a fairly complex and nascent subject with a lot of variables, so in this article, we'll introduce you to the subject and let you know how you can get started. </span></p>
</div>

<p>The key consideration when streaming media to a browser is the fact that rather than playing a finite file we are relaying a file that is being created on the fly and has no pre-determined start or end.</p>

<h2 id="Key_differences_between_streamed_and_static_media">Key differences between streamed and static media</h2>

<p>In this case, we are using static media to describe media that is represented by a file, whether it be an mp3 or WebM file. This file sits on a server and can be delivered — like most other files — to the browser. This is often known as a progressive download.</p>

<p>Live streamed media lacks a finite start and end time as rather than a static file, it is a stream of data that the server passes on down the line to the browser and is often adaptive (see below). Usually, we require different formats and special server-side software to achieve this.</p>

<h2 id="Adaptive_streaming">Adaptive streaming</h2>

<p>One of the main priorities for live streaming is to keep the player synchronized with the stream: adaptive streaming is a technique for doing this in the case of low bandwidth. The idea is that the data transfer rate is monitored and if it looks like it's not keeping up, we drop down to a lower bandwidth (and consequently lower quality) stream. In order to have this capability, we need to use formats that facilitate this. Live streaming formats generally allow adaptive streaming by breaking streams into a series of small segments and making those segments available at different qualities and bit rates.</p>

<h2 id="Streaming_Audio_and_Video_on_Demand">Streaming Audio and Video on Demand</h2>

<p>Streaming technology is not used exclusively for live streams. It can also be used instead of the traditional progressive download method for Audio and Video on demand:</p>

<p>There are several advantages to this:</p>

<ul>
	<li>Latency is generally lower so media will start playing more quickly</li>
	<li>Adaptive streaming makes for better experiences on a variety of devices</li>
	<li>Media is downloaded just in time which makes bandwidth usage more efficient</li>
</ul>

<h2 id="Streaming_Protocols">Streaming Protocols</h2>

<p>While static media is usually served over HTTP, there are several protocols for serving adaptive streams; let's take a look at the options.</p>

<h3 id="HTTP">HTTP</h3>

<p>For now, HTTP is by far the most commonly supported protocol used to transfer media on demand or live.</p>

<h3 id="RTMP">RTMP</h3>

<p>Real Time Messaging Protocol (RTMP) is a proprietary protocol developed by Macromedia (now Adobe) and supported by the Adobe Flash plugin. RTMP comes in various flavours including RTMPE (Encrypted), RTMPS (Secure over SSL/TLS) and RTMPT (encapsulated within HTTP requests).</p>

<h3 id="RTSP">RTSP</h3>

<div class="note">
<p>Real Time Streaming Protocol (RTSP) controls media sessions between endpoints and is often used together with Real-time Transport Protocol (RTP) and with Real-time Control Protocol (RTCP) for media stream delivery. Using RTP with RTCP allows for adaptive streaming. This is not yet supported natively in most browsers, but be aware that <a href="http://www.mozilla.org/en-US/firefox/os/notes/1.3/">Firefox OS 1.3 supports RTSP</a>.<br>
<br>
<strong>Note</strong>: some vendors implement propriety transport protocols, such as RealNetworks and their Real Data Transport (RDT).</p>
</div>

<h3 id="RTSP_2.0">RTSP 2.0</h3>

<p>RTSP 2.0 is currently in development and is not backward compatible with RTSP 1.0.</p>

<div class="warning">
<p><strong>Important</strong>: Although the {{ htmlelement("audio") }} and {{ htmlelement("video") }} tags are protocol agnostic, no browser currently supports anything other than HTTP without requiring plugins, although this looks set to change. Protocols other than HTTP may also be subject to blocking from firewalls or proxy servers.</p>
</div>

<h2 id="Using_streaming_protocols">Using streaming protocols</h2>

<p>The process of using the various protocols is reassuringly familiar if you are used to working with media over HTTP.</p>

<p>For example:</p>

<pre class="brush: html">&lt;video src="rtsp://myhost.com/mymedia.format"&gt;
 &lt;!-- Fallback here --&gt;
&lt;/video&gt;</pre>

<h2 id="Media_Source_Extensions_(MSE)">Media Source Extensions (MSE)</h2>

<p><a href="https://dvcs.w3.org/hg/html-media/raw-file/tip/media-source/media-source.html">Media Source Extensions</a> is a W3C working draft that plans to extend {{ domxref("HTMLMediaElement") }} to allow JavaScript to generate media streams for playback. Allowing JavaScript to generate streams facilitates a variety of use cases like adaptive streaming and time shifting live streams.<br>
<br>
For example,  <a href="https://web.archive.org/web/20170504035455/https://msopentech.com/blog/2014/01/03/streaming_video_player/">you could implement MPEG-DASH using JavaScript while offloading the decoding to MSE</a>.</p>

<div class="note">
<p><strong>Note</strong>: Time Shifting is the process of consuming a live stream sometime after it happened.</p>
</div>

<h2 id="Video_Streaming_File_Formats">Video Streaming File Formats</h2>

<p>A couple of HTTP-based live streaming video formats are beginning to see support across browsers.</p>

<div class="note">
<p><strong>Note</strong>: You can find a guide to encoding HLS and MPEG-DASH for use on the web at <a href="/en-US/Apps/Build/Manipulating_media/Setting_up_adaptive_streaming_media_sources">Setting up adaptive streaming media sources</a>.</p>
</div>

<h3 id="MPEG-DASH">MPEG-DASH</h3>

<p>DASH stands for Dynamic Adaptive Streaming over HTTP and is a new format that has recently seen support added to Chrome, and Internet Explorer 11 running on Windows 8.1. It is supported via Media Source Extensions which are used by JavaScript libraries such as <a href="https://github.com/Dash-Industry-Forum/dash.js/">DASH.js</a>. This approach allows us to download chunks of the video stream using XHR and "append" the chunks to the stream that's played by the {{ htmlelement("video") }} element. So for example, if we detect that the network is slow, we can start requesting lower quality (smaller) chunks for the next segment. This technology also allows an advertising segment to be appended/inserted into the stream.</p>

<div class="note">
<p><strong>Note</strong>: you can also <a href="http://wiki.webmproject.org/adaptive-streaming/webm-dash-specification">use WebM with the MPEG DASH adaptive streaming system</a>.</p>
</div>

<h3 id="HLS">HLS</h3>

<p>HLS or HTTP Live Streaming is a protocol invented by Apple Inc and supported on iOS, Safari and the latest versions of Android browser / Chrome. HLS is also adaptive.<br>
<br>
HLS can also be decoded using JavaScript, which means we can support the latest versions of Firefox, Chrome and Internet Explorer 10+. See this <a href="https://github.com/dailymotion/hls.js">HTTP Live Streaming JavaScript player</a>.<br>
<br>
At the start of the streaming session, an <a href="http://en.wikipedia.org/wiki/M3U8#Extended_M3U_directives">extended M3U (m3u8) playlist</a> is downloaded. This contains the metadata for the various sub-streams that are provided.</p>

<h3 id="Streaming_File_Format_Support">Streaming File Format Support</h3>

<table>
	<thead>
		<tr>
			<th>Browser</th>
			<th>DASH</th>
			<th>HLS</th>
			<th>Opus (Audio)</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>Firefox 32</td>
			<td>✓ [1]</td>
			<td>✓ [2]</td>
			<td>✓ 14+</td>
		</tr>
		<tr>
			<td>Safari 6+</td>
			<td> </td>
			<td>✓</td>
			<td> </td>
		</tr>
		<tr>
			<td>Chrome 24+</td>
			<td>✓ [1]</td>
			<td>✓</td>
			<td> </td>
		</tr>
		<tr>
			<td>Opera 20+</td>
			<td>✓ [1]</td>
			<td> </td>
			<td> </td>
		</tr>
		<tr>
			<td>Internet Explorer 10+</td>
			<td>✓ 11</td>
			<td>✓ [2]</td>
			<td> </td>
		</tr>
		<tr>
			<td>Firefox Mobile</td>
			<td>✓</td>
			<td>✓</td>
			<td>✓</td>
		</tr>
		<tr>
			<td>Safari iOS6+</td>
			<td> </td>
			<td>✓</td>
			<td> </td>
		</tr>
		<tr>
			<td>Chrome Mobile</td>
			<td>✓</td>
			<td>✓ [2]</td>
			<td> </td>
		</tr>
		<tr>
			<td>Opera Mobile</td>
			<td>✓ [1]</td>
			<td>✓</td>
			<td> </td>
		</tr>
		<tr>
			<td>Internet Explorer Mobile</td>
			<td>✓ 11</td>
			<td>✓ [2]</td>
			<td> </td>
		</tr>
		<tr>
			<td>Android</td>
			<td>✓</td>
			<td> </td>
			<td> </td>
		</tr>
	</tbody>
</table>

<p>[1] Via JavaScript and MSE</p>

<p>[2] Via JavaScript and a CORS Proxy</p>

<h3 id="Video_Fallbacks">Video Fallbacks</h3>

<p>Between DASH and HLS we can cover a significant portion of modern browsers but we still need a fallback if we want to support the rest.<br>
<br>
One popular approach is to use a Flash fallback that supports RTMP. Of course, we then have the issue that we need to encode in three different formats.</p>

<h2 id="Audio_Streaming_File_Formats">Audio Streaming File Formats</h2>

<p>There are also some audio formats beginning to see support across browsers.</p>

<h3 id="Opus">Opus</h3>

<p>Opus is a royalty-free and open format that manages to optimize quality at various bit-rates for different types of audio. Music and speech can be optimized in different ways and Opus uses the SILK and CELT codecs to achieve this.<br>
<br>
Currently, Opus is supported by Firefox desktop and mobile as well as the latest versions of desktop Chrome and Opera.</p>

<div class="note">
<p><strong>Note</strong>: <a href="http://tools.ietf.org/html/draft-ietf-rtcweb-audio-05">Opus is a mandatory format</a> for WebRTC browser implementations.</p>
</div>

<h3 id="MP3_AAC_Ogg_Vorbis">MP3, AAC, Ogg Vorbis</h3>

<p>Most common audio formats can be streamed using specific server-side technologies.</p>

<p>Note: It's potentially easier to stream audio using non-streaming formats because unlike video there are no keyframes.</p>

<h2 id="Server-side_Streaming_Technologies">Server-side Streaming Technologies</h2>

<p>In order to stream live audio and video, you will need to run specific streaming software on your server or use third-party services.</p>

<h3 id="GStreamer">GStreamer</h3>

<p><a href="http://gstreamer.freedesktop.org/">GStreamer</a> is an open source cross-platform multimedia framework that allows you to create a variety of media-handling components, including streaming components. Through its plugin system, GStreamer provides support for more than a hundred codecs (including MPEG-1, MPEG-2, MPEG-4, H.261, H.263, H.264, RealVideo, MP3, WMV, and FLV.)</p>

<p>GStreamer plugins such as <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gst-plugins-good-plugins/html/gst-plugins-good-plugins-plugin-soup.html">souphttpclientsink</a> and <a href="https://gstreamer.freedesktop.org/data/doc/gstreamer/head/gst-plugins-good/html/gst-plugins-good-plugins-shout2send.html">shout2send</a> exist to stream media over HTTP. You can also integrate with Python's Twisted framework or use something like <a href="http://www.flumotion.net/features/">Flumotion</a> (open source streaming software).</p>

<p>For RTMP transfer you can use the <a href="https://github.com/arut/nginx-rtmp-module">Nginx RTMP Module</a>.</p>

<h3 id="SHOUTcast">SHOUTcast</h3>

<p><a href="http://en.wikipedia.org/wiki/SHOUTcast">SHOUTcast</a> is a cross-platform proprietary technology for streaming media. Developed by Nullsoft, it allows digital audio content in MP3 or AAC format to be broadcast. For web use, SHOUTcast streams are transmitted over HTTP.</p>

<p><strong>Note</strong>: <a href="http://stackoverflow.com/questions/2743279/how-could-i-play-a-shoutcast-icecast-stream-using-html5">SHOUTcast URLs may require a semi-colon to be appended to them</a>.</p>

<h3 id="Icecast">Icecast</h3>

<p>The <a href="http://www.icecast.org/">Icecast</a> server is an open source technology for streaming media. Maintained by the <a href="http://www.xiph.org/">Xiph.org Foundation</a>, it streams Ogg Vorbis/Theora as well as MP3 and AAC format via the SHOUTcast protocol.</p>

<p><strong>Note</strong>: SHOUTcast and Icecast are among the most established and popular technologies, but there are many <a href="http://en.wikipedia.org/wiki/List_of_streaming_media_systems#Servers">more streaming media systems available</a>.</p>

<h3 id="Streaming_Services">Streaming Services</h3>

<p>Although you can install software like GStreamer, SHOUTcast and Icecast you will also find a lot of <a href="http://en.wikipedia.org/wiki/Comparison_of_streaming_media_systems">third-party streaming services</a> that will do much of the work for you.</p>

<h2 id="See_Also">See Also</h2>

<ul class="task-list">
	<li><a href="http://en.wikipedia.org/wiki/HTTP_Live_Streaming">HTTP Live Streaming</a></li>
	<li><a href="http://www.jwplayer.com/html5/hls/">HLS Browser Support</a></li>
	<li><a href="https://github.com/RReverser/mpegts">HTTP Live Streaming JavaScript player</a></li>
	<li><a href="https://larryjordan.com/articles/basics-of-http-live-streaming/">The Basics of HTTP Live Streaming</a></li>
	<li><a href="/en-US/docs/DASH_Adaptive_Streaming_for_HTML_5_Video">DASH Adaptive Streaming for HTML 5 Video</a></li>
	<li><a href="http://en.wikipedia.org/wiki/Dynamic_Adaptive_Streaming_over_HTTP">Dynamic Adaptive Streaming over HTTP (MPEG-DASH)</a></li>
	<li><a href="http://dash-mse-test.appspot.com/media.html">MPEG-DASH Media Source Demo</a></li>
	<li><a href="http://dashif.org/reference/players/javascript/1.0.0/index.html">DASH Reference Client</a></li>
	<li><a href="http://en.wikipedia.org/wiki/Dynamic_Adaptive_Streaming_over_HTTP">Dynamic Streaming over HTTP</a></li>
	<li><a href="http://www.streamingmediaglobal.com/Articles/Editorial/Featured-Articles/The-State-of-MPEG-DASH-Deployment-96144.aspx">The State of MPEG-DASH Deployment</a></li>
	<li><a href="http://www.bbc.co.uk/rd/blog/2014/03/media-source-extensions">Look, no plugins: Live streaming to the browser using Media Source Extensions and MPEG-DASH</a></li>
	<li><a href="https://dvcs.w3.org/hg/html-media/raw-file/tip/media-source/media-source.html">Media Source Extensions (W3C)</a></li>
	<li><a href="http://en.wikipedia.org/wiki/Icecast">Icecast</a></li>
	<li><a href="http://en.wikipedia.org/wiki/Shoutcast">SHOUTcast</a></li>
	<li><a href="http://en.wikipedia.org/wiki/GStreamer">GStreamer</a></li>
	<li><a href="https://coaxion.net/blog/2013/10/streaming-gstreamer-pipelines-via-http/">Streaming GStreamer Pipelines Via HTTP</a></li>
	<li><a href="http://www.svesoftware.com/passkeeper/cms/article/streaming-media-using-gstreamer-web/">Streaming media using GStreamer on the web</a></li>
	<li><a href="http://nginx-rtmp.blogspot.it/2013/07/gstreamer-and-raspberry-pi.html">GStreamer and Raspberry Pi</a></li>
	<li><a href="http://msopentech.com/blog/2014/01/09/acceptance-media-source-extensions-w3c-candidate-recommendation-will-accelerate-adoption-dash-js/">Acceptance of Media Source Extensions as W3C Candidate Recommendation will accelerate adoption of dash.js</a></li>
	<li><a href="http://en.wikipedia.org/wiki/Comparison_of_streaming_media_systems">Comparison of Streaming Media Systems</a></li>
	<li><a href="https://hacks.mozilla.org/2015/07/streaming-media-on-demand-with-media-source-extensions/">Mozilla Hacks - Streaming Media on demand with Media Source Extensions</a></li>
</ul>

<p><br>
 </p>




